<?php







class MiniAllDatasource extends MiniGenericDatasource {

 var $enableDirectLanguageSelection;
 var $selector = null;
 var $searchers = null;

 function MiniAllDatasource($ttypes) {
 global $DB;
 $this->MiniDatasource();
 $this->hasHeader = false;
 $this->cols = array();
 $this->colheader = array();
 $this->colshow = array();
 $this->colsort = array();
 $this->sortedcol = "";
 $this->sortedway = "ASC";
 $this->ttypes = $ttypes;
 }

 



 function setSearchers($searchers) {
 $this->searchers = $searchers;
 }

 function setSelector(&$selector) {
 $this->selector =& $selector;
 }

 function enableDirectLanguageSelection( $enable=TRUE ) {
 $this->enableDirectLanguageSelection = $enable;
 }
 
 function getResultSet( $fromIdx, $toIdx, &$count, $search = "", $fetchAll = false, $columnFilters = false ) {
 global $CONTENTGROUPS;

 
 load_contentgroups();
 $ret = array();

 
 global $SHOW_ALL_CONTENTGROUPS;
 $SHOW_ALL_CONTENTGROUPS = true;

 foreach($this->ttypes as $ttype) {
 if ($columnFilters && $this->isColumnVisible('type') && is_array($columnFilters['type']) && in_array($ttype, $columnFilters['type'])) {
 continue;
 }
 $searcherId = $this->getFolderType().".".$this->getFolderID().".".$ttype;
 if ($this->searchers && $this->searchers[$searcherId]) {
 $searcher = $this->searchers[$searcherId];
 } else {
 $searcher = NodeFactory::getStaticInstanceOf($ttype);
 }
 $objs = $searcher->searchInObject($this->getFolderType(), $this->getFolderID(), $search, true);
 
 if (!is_array($objs)) {
 $objs = array();
 }
 foreach ($objs as $obj) {
 
 $id = $obj->getTType().".".$obj->getID();
 $selStatus = "";
 if ($obj->getTType() == T_PAGE) {
 $langvariants = $obj->getFieldValue('languagevariants');
 $lang = "";
 if (is_array($langvariants)) {
 foreach ( $langvariants as $cgId => $variant ) {
 $variantId = $variant->getTType().".".$variant->getID();
 $selIcon = $this->selector->renderSelection( $variantId, $cgId );
 $lang .= '<a href="' .$this->buildLink($variantId) .'">'.$selIcon.'</a>';
 }
 }
 } else {
 $lang = "";
 }
 if ($this->selector) {
 if ($columnFilters && is_array($columnFilters['icon'])) {
 $selStatus = $this->selector->getSelectionStatus( $id );
 if (in_array($selStatus, $columnFilters['icon'])) {
 continue;
 }
 }

 $selIcon = $this->selector->renderSelection( $id );
 if ($obj->getTType() == T_PAGE) {
 $id = $id .".a";
 }
 $ret[] = array('id' => $id, 'obj_id' => $obj->getID(), 'name' => $obj->getDisplayName(), 'type' => $obj->getCategoryName(), 'icon' => '<img src="' . $obj->getIcon() . '"/> <a href="' .$this->buildLink($id) .'">'.$selIcon.'</a>', 'language' => $lang, 'folderpath' => $obj->folderpath);
 } else {
 $ret[] = array('id' => $id, 'obj_id' => $obj->getID(), 'name' => '<a href="' .$this->buildLink($id) .'">'.$obj->getDisplayName().'</a>', 'type' => $obj->getCategoryName(), 'icon' => '<img src="' . $obj->getIcon() . '"/>', 'language' => $lang, 'folderpath' => $obj->folderpath);
 }
 }
 }

 
 $SHOW_ALL_CONTENTGROUPS = false;

 
 global $sortcol, $sortway, $selector;
 $sortcol = $this->sortedcol;
 $sortway = $this->sortedway;
 $selector =& $this->selector;

 usort($ret, "sortfunction");
 $count = count($ret);
 $ret = array_slice($ret, $fromIdx, $toIdx - $fromIdx + 1);
 return $ret;
 }

 function initItemList(&$lst) {
 global $T_TYPE;

 
 
 if (! $this->sortedcol == "type") {
 $lst->setNextSortWay("type");
 $this->sortedcol = "type";
 }
 $lst->setGroupableColumns( array( 'type' ) );

 
 $filter = array();
 foreach ($this->ttypes as $ttype) {
 $searchObject = NodeFactory::getStaticInstanceOf($ttype);
 $parentTType = $searchObject->getParentTType();
 if (in_array($this->getFolderType(), $parentTType)) {
 $filter[$ttype] = array("label" => $T_TYPE[$ttype]["name"], "icon" => $searchObject->getIcon(), "text" => $T_TYPE[$ttype]["name"]);
 }
 }
 $lst->d_ds->setColumnFilter('type', $filter);
 }

 function getKey() {
 return "minipageds_".$this->getFolderID()."_".$this->getFolderType();
 }

 function isSearchable() {
 return true;
 }

 function getDefaultItemsPerPageCount() { 
 global $FEATURE, $MAXLISTITEMS, $DEFAULT_MAXLISTITEMS;

 if($FEATURE['itemlist_configurepagesize']) {
 
 if($MAXLISTITEMS) return $MAXLISTITEMS;
 if($DEFAULT_MAXLISTITEMS) return $DEFAULT_MAXLISTITEMS;
 }

 
 return 939821;
 }

 function getRowHelp( $rowKey, $rowData ) {
 return "ID: ".$rowData["obj_id"];
 }
}

function sortfunction($a, $b) {
 global $sortcol, $sortway, $selector;

 if ($sortcol == "icon" && $selector) {
 $aval = 0;
 $bval = 0;
 if ($selector->isSelected($a["id"])) {
 $aval = 4;
 } else if ($selector->isExcluded($a["id"])) {
 $aval = 2;
 } else if ($selector->isAutoSelected($a["id"])) {
 $aval = 3;
 } else if ($selector->isAutoExcluded($a["id"])) {
 $aval = 1;
 }
 if ($selector->isSelected($b["id"])) {
 $bval = 4;
 } else if ($selector->isExcluded($b["id"])) {
 $bval = 2;
 } else if ($selector->isAutoSelected($b["id"])) {
 $bval = 3;
 } else if ($selector->isAutoExcluded($b["id"])) {
 $bval = 1;
 }
 return ($aval - $bval) * ($sortway == "ASC" ? 1 : -1);
 } else {
 if ($a[$sortcol] == null && $b[$sortcol] == null) {
 return 0;
 } else if ($a[$sortcol] == null) {
 return $sortway == "ASC" ? 1 : -1;
 } else if ($b[$sortcol] == null) {
 return $sortway == "ASC" ? -1 : 1;
 }
 return strcasecmp($a[$sortcol], $b[$sortcol])*($sortway == "ASC" ? 1 : -1); 
 }
}

?>
